/* Return exit value of asynchronous I/O request.
   Copyright (C) 1997, 2002, 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */


/* We use an UGLY hack to prevent gcc from finding us cheating.  The
   implementation of aio_return and aio_return64 are identical and so
   we want to avoid code duplication by using aliases.  But gcc sees
   the different parameter lists and prints a warning.  We define here
   a function so that aio_return64 has no prototype.  */
#define aio_return64 XXX
#include <aio.h>
/* And undo the hack.  */
#undef aio_return64

#include <kaio_misc.h>

#ifndef USE_KAIO
#include <aio_return.c>
#else

#include <errno.h>

ssize_t
aio_return (aiocbp)
     struct aiocb *aiocbp;
{
  if (aiocbp->__error_code == EINPROGRESS)
    __aio_read_one_event ();
  return aiocbp->__return_value;
}

weak_alias (aio_return, aio_return64)
#endif
